// Nathan E. Moore
// March 2, 2005

#include "taskalloc.h"
#include "common.h"
#include <stdexcept>
#include <objbase.h>

namespace com
{
	TaskAlloc::TaskAlloc()
		:allocator_()
	{
		if (FAILED(CoGetMalloc(1, &(GetImplRef(allocator_)))))
			throw std::runtime_error(ERROR_MSG("CoGetMalloc failed."));
	}

	TaskAlloc::IMallocPtr & TaskAlloc::Get()
	{
        return TASingleton::Instance().allocator_;
	}

	void* TaskAlloc::Alloc(std::size_t bytes)
	{
		void* temp = Get()->Alloc(bytes);
		if (!temp)
			throw std::bad_alloc(ERROR_MSG("IMalloc::Alloc failed."));

		return temp;
	}

	void TaskAlloc::Free(void* ptr)
	{
		Get()->Free(ptr);
	}
}	// end namespace com
